--[[
½߼
]]--
require("common.baseclass")
require("actionEvent.LoginActionHandler")
require("actionEvent.HttpHandler")
require("gameevent.LoginUIHandler")
require("object.manager.LoginManager")
require "object.server.ServerMgr"
require("object.tips.TipsManager")
require("object.manager.NotifyManager")
require("object.manager.StatisticsMgr")
require("object.manager.LoginSettingMgr")


LoginWorld = LoginWorld or BaseClass()

function LoginWorld:__init()
	LoginWorld.Instance = self	
	self.tipsManager = TipsManager.New()	
	self.loginManager = LoginManager.New()
	self.serverMgr = ServerMgr.New()  --
	self.notifyManager = NotifyManager.New()  --
	self.statisticsMgr = StatisticsMgr.New()  --̨ͳ	
	self.loginSettingMgr = LoginSettingMgr.New() --¼

	self.uiHandler = {}
	self.actionHandler = {}
	-- ʼhandler
	self:initUIHandler()
	self:initActionHandler()	
end

function LoginWorld:__delete()

end

function LoginWorld:getLoginManager()
	return self.loginManager
end

function LoginWorld:getTipsManager()
	return self.tipsManager
end
--
function LoginWorld:getServerMgr()
	return self.serverMgr	
end

--
function LoginWorld:getNotifyManager()
	return self.notifyManager
end	

function LoginWorld:getStatisticsMgr()
	return self.statisticsMgr
end

function LoginWorld:getLoginSettingMgr()
	return self.loginSettingMgr
end

function LoginWorld:addUIHandler(nHandler)
	table.insert(self.uiHandler,nHandler)
end

function LoginWorld:initUIHandler()
	self:addUIHandler(LoginUIHandler.New())
end	

function LoginWorld:addActionHandler(nHandler)
	table.insert(self.actionHandler,nHandler)
end

function LoginWorld:initActionHandler()
	self:addActionHandler(LoginActionHandler.New())
	self:addActionHandler(HttpHandler.New())
end

function LoginWorld:getUIHandlerByName(name)
	for k,v in pairs(self.uiHandler) do
		if v.handleName == name then
			return v
		end
	end
end

--ʱ
function print_r(aTable, title)

    if not aTable then return end
    if type(aTable) ~= "table" then 
        print("table:",aTable)
    return end

    local enterStr  = "\n"
    local indentStr = "    "
    local equalStr  = " = "
    local commaStr  = ","
    local leftBrace = "{"
    local rightBrace = "}"

    local strParts  = {}

    local function recursionFunc(aTable, indent)

        -- table
        table.insert(strParts, enterStr)
        table.insert(strParts, string.rep(indentStr, indent))
        table.insert(strParts, leftBrace)
        table.insert(strParts, enterStr)

        -- 2
        local curTabStr = string.rep(indentStr, indent + 1)

        for k,v in pairs(aTable) do

            -- table ݹ
            if type(v) == "table" then
                table.insert(strParts, curTabStr)
                table.insert(strParts, tostring(k))
                table.insert(strParts, equalStr)
                recursionFunc(v, indent + 1)

            else
                --  ֱӴӡ
                table.insert(strParts, curTabStr)
                table.insert(strParts, tostring(k))
                table.insert(strParts, equalStr)
                table.insert(strParts, tostring(v))
                table.insert(strParts, commaStr)
                table.insert(strParts, enterStr)
            end
        end

        -- tableһ
        table.insert(strParts, string.rep(indentStr, indent))
        table.insert(strParts, rightBrace)
        table.insert(strParts, commaStr)
        table.insert(strParts, enterStr)
    end

    if title then
        table.insert(strParts, title)
        table.insert(strParts, equalStr)
    end
    recursionFunc(aTable, 0)

    CCLuaLog(table.concat(strParts))
end