require("common.baseclass")

LoginBaseUI = LoginBaseUI or BaseClass()
local scale = VisibleRect:SFGetScale()
local visibleSize = CCDirector:sharedDirector():getVisibleSize()

local UIZOrder = 
{
	TopLeftNode = 100,
	Bg = -1,
}

TitleAlign = {
	Left = 1,
	Center = 2
}

ClosebtnType = {
	Close = 1,
	Back = 2,
}

local formImagePos = ccp(0, 0)
local formMenuHeight = 48
local formSpace = 21

function LoginBaseUI:__init()
	self.rootNode = CCLayer:create()
	self.rootNode:setTouchEnabled(true)	
	self.rootNode:setContentSize(visibleSize)
	self.rootNode:retain()
	
	self.contentNode = CCNode:create()
	self.contentNode:setContentSize(visibleSize)
	self.contentNode:retain()
	self.rootNode:addChild(self.contentNode, 2)
	
	self.formTitle = nil
	self.formImage = nil
	
	self.viewName = ""
	self.topLeftNode = nil
	self.btnClose = nil
	self:registerScriptTouchHandler()
end

function LoginBaseUI:__delete()
	if self.contentNode then
		self.contentNode:release()
		self.contentNode = nil
	end
	if self.rootNode then
		self.rootNode:release()
		self.rootNode = nil
	end
end

function LoginBaseUI:registerScriptTouchHandler()
	local function ccTouchHandler(eventType, x,y)
		return self:touchHandler(eventType, x, y)
	end
	if self.rootNode.registerScriptTouchHandler then
		self.rootNode:registerScriptTouchHandler(ccTouchHandler, false,UIPriority.View, true)
	end
end

function LoginBaseUI:touchHandler(eventType, x, y)
	if self.rootNode and self.rootNode:isVisible() and self.rootNode:getParent() then	
		local parent = self.rootNode:getParent()
		local point = parent:convertToNodeSpace(ccp(x,y))
		local rect = self.rootNode:boundingBox()
		if rect.containsPoint and rect:containsPoint(point) then
			return 1
		else
			return 0
		end
	else
		return 0
	end
end	

-- ͬCCNodeaddChild
function LoginBaseUI:addChild(node, zorder, tag)
	if node then
		if type(zorder) == "number" then
			self.contentNode:addChild(node, zorder)
		else
			self.contentNode:addChild(node)
		end
		
		if type(tag) == "number" then
			node:setTag(tag)
		end
	end
end

function LoginBaseUI:removeChild(node)
	if (node) then
		self.contentNode:removeChild(node, true)
		node = nil
	end
end

function LoginBaseUI:getRootNode()
	return self.rootNode
end

function LoginBaseUI:getContentNode()
	return self.contentNode
end

function LoginBaseUI:SetSize(size)
	self.rootNode:setContentSize(size)
	local rootNodeSize = CCSizeMake(size.width-42, size.height-69)
	self.contentNode:setContentSize(rootNodeSize)	
	
	VisibleRect:relativePosition(self.contentNode, self.rootNode, LAYOUT_TOP_INSIDE + LAYOUT_CENTER_X, ccp(0, -48))
	self.viewSize = CCSizeMake(size.width-42, size.height-69)
	self:updateContentNode()
	VisibleRect:relativePosition(self.titleBg,self.background,LAYOUT_CENTER_X+LAYOUT_TOP_INSIDE,ccp(0,-6), false)
	VisibleRect:relativePosition(self.btnClose,self.background,LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-12,-12))
end

-- Ѵھ
function LoginBaseUI:makeMeCenter()
	local posX = (visibleSize.width - self.rootNode:getContentSize().width)/2
	local posY = (visibleSize.height - self.rootNode:getContentSize().height)/2
	
	self.rootNode:setPosition(posX, posY)
end

-- Ͻͼ
function LoginBaseUI:setFormImage(imageNode, offset)
	-- if imageNode then
	-- 	if self.formImage then
	-- 		self.formImage:removeFromParentAndCleanup(true)	
	-- 	end
		
	-- 	self.formImage = imageNode
	-- 	self.imageBg = createSpriteWithFrameName(RES("login_common_lefttop_bg.png"))
	-- 	self.rootNode:addChild(self.imageBg,300)
	-- 	VisibleRect:relativePosition(self.imageBg, self.rootNode, LAYOUT_LEFT_INSIDE + LAYOUT_TOP_INSIDE, ccp(-25, 30))
	-- 	self.rootNode:addChild(imageNode,300)
	-- 	if offset then 
	-- 		VisibleRect:relativePosition(imageNode, self.imageBg, LAYOUT_CENTER, offset)
	-- 	else			
	-- 		VisibleRect:relativePosition(imageNode, self.imageBg, LAYOUT_CENTER)
	-- 	end
	-- end
end

-- ñ
function LoginBaseUI:setFormTitle(titleNode, align)
	if titleNode then
		if self.formTitle then
			self.formTitle:removeFromParentAndCleanup(true)	
		end
		
		self.formTitle = titleNode
		if align > TitleAlign.Center or align < TitleAlign.Left then
			CCLuaLog("Warning!!setFormTitle use undefine align")
			align = TitleAlign.Left
		end
		
		self.rootNode:addChild(titleNode,1)
		if align == TitleAlign.Left then
			if self.formImage then
				VisibleRect:relativePosition(titleNode, self.formImage, LAYOUT_RIGHT_OUTSIDE, ccp(5, 0))
			else
				VisibleRect:relativePosition(titleNode, self.rootNode, LAYOUT_LEFT_INSIDE, ccp(21, 0))
			end
		else
			VisibleRect:relativePosition(titleNode, self.rootNode, LAYOUT_CENTER_X, ccp(0, 0))
		end
		
		-- Ա
		local space = (formMenuHeight - titleNode:getContentSize().height)/2 + 5
		VisibleRect:relativePosition(titleNode, self.rootNode, LAYOUT_TOP_INSIDE, ccp(0, -space))
	end
end

function LoginBaseUI:initFullScreen()
	local fullScreenSize = CCSizeMake(874, 564)
	self:init(fullScreenSize)
	return fullScreenSize
end

function LoginBaseUI:initHalfScreen()
	local halfScreenSize = CCSizeMake(416, 564)
	self:init(halfScreenSize)
	return halfScreenSize
end

-- ʼʹĬϵıͼԼʾرհť
function LoginBaseUI:init(size, pos)
	
	local viewSize
	if size then
		viewSize = CCSizeMake(size.width*scale,size.height*scale)
	else
		viewSize = visibleSize
	end
	
	self.rootNode:setContentSize(viewSize)
	local size = CCSizeMake(viewSize.width-42, viewSize.height-69)
	self.contentNode:setContentSize(size)
	VisibleRect:relativePosition(self.contentNode, self.rootNode, LAYOUT_TOP_INSIDE + LAYOUT_CENTER_X, ccp(0, -48))	
	
	if pos then
		-- self.rootNode:setPosition(pos)
	else
		self:makeMeCenter()
	end
	
	-- ͼ
	--todo
	local rect = CCRectMake(71,14,2,20)
	self:createBackground(viewSize,nil,rect)
	
	-- رհť
	self:createCloseBtn()
	
end

function LoginBaseUI:updateContentNode()
	local size = CCSizeMake(self.rootNode:getContentSize().width-42, self.rootNode:getContentSize().height-69)
	self.contentNode:setContentSize(size)
	VisibleRect:relativePosition(self.contentNode, self.rootNode, LAYOUT_TOP_INSIDE + LAYOUT_CENTER_X, ccp(0, -48))
end

-- ʹԶ屳гʼ
-- size: С
-- bgImage: ͼƬ
-- bShowCloseBtn: Ϊtrueʱʾرհťʾť
function LoginBaseUI:initWithBg(size, bgImage, bShowCloseBtn, bShowTitleBg, rrect)
	self.rootNode:setContentSize(VisibleRect:getScaleSize(size))
	self:updateContentNode()
	self:createBackground(size, bgImage, rrect)
	if (bShowCloseBtn == true) then
		self:createCloseBtn()
	end
end

function LoginBaseUI:removeFromRootNode(node)
	if (node) then
		self.rootNode:removeChild(node, true)
		node = nil
	end
end

function LoginBaseUI:reload()

	CCLuaLog("======login ui reload")

	local reloadTable ={
		"ui.UIManager",
		"common.BaseUI",
		"common.UIBase",
		"GameDef",
		"config.words",
		"ui.UIFactory",
		"config.image",

		"object.bag.ItemDetailArg",
		"gameevent.NearbyUIHandle"
	}
	for k,v in pairs( reloadTable ) do
        package.loaded[v] = nil 
        require(v)
    end	

	reloadTB = reloadTB or {}
	
	local DIR_ALL = 0
	local DIR_FILE = 1
	local DIR_DIRECTIORY = 2
	local function dir(directory, type)
	    local i, t, popen = 0, {}, io.popen

	    local attr = ''     -- dir /aĲ
	    if(type == DIR_FILE) then attr = '-d' end
	    if(type == DIR_DIRECTIORY) then attr = 'd' end

	    --print(popen("cd"):read())

	    for filename in popen('dir "'..directory..'" /b /a'..attr):lines() do --Windows,Լ޸dirĲΪоĿ¼
	        i = i + 1
	        t[i] = filename
	    end

	    --print_r(t,"t")
	    return t
	end
	
	local function addLuaFile(path, srcPath)
	    tb = dir(path)
	    --CCLuaLog("srcPath:"..srcPath)

	    for k,fileOrDirName in pairs(tb) do 
	    	if string.find(fileOrDirName, "%.") then --ļ
	   			local filename = fileOrDirName:match("(.+)%.%w+$")
	   			local path = string.gsub(path,srcPath,"")
	   			--CCLuaLog(path)
	   			local path = string.gsub(path,"\\",".")
	   			--CCLuaLog(path)
		        filename = path.."."..filename
		        --CCLuaLog(filename)
		        package.loaded[filename] = nil 
		        require(filename)
		        table.insert(reloadTB,k,filename)
		    else
		    	addLuaFile(path.."\\"..fileOrDirName,srcPath)
		    end
		end
	end
	if table.isEmpty(reloadTB) then
		local currentPath = io.popen("cd"):read()
		local loginRoot = currentPath.."\\base\\loginScript\\"
		--CCLuaLog("scriptRoot:"..scriptRoot)
		--CCLuaLog("reload in os")
		addLuaFile(currentPath.."\\base\\loginScript\\ui", loginRoot)
		addLuaFile(currentPath.."\\base\\loginScript\\common", loginRoot)
	else
		--CCLuaLog("reload in table")
		for k,v in pairs(reloadTB) do
			package.loaded[v] = nil 
		    require(v)
		    --CCLuaLog(v)
		end

	end

	for k,v in pairs(UIManager.Instance.uiList) do
		UIManager.Instance:releaseUI(v.viewName)
	end

	-- UIManager.Instance:closeAllUI()
	-- GlobalEventSystem:Fire(GameEvent.EVENT_MAIN_UI)

	--self:close()
	if self.callback ~=nil then
		self.callback()
	else
		UIManager.Instance:showUI(self.viewName)
	end

	-- local UseVip = UIManager.Instance:showPromptBox("UseVipCard",1,true)
	-- UseVip:setBtn("word_button_use.png",onUseVip, refId)
	-- UseVip:setTitleWords(Config.Words[13017])
end
--delayӳٶʧĬ3 touchArea:ɵĬrootNodeĵ¼
function LoginBaseUI:showLoadingHUD(delay,func,touchArea)
	local manager =UIManager.Instance
	manager:showLoadingHUD(delay,self.rootNode,func,touchArea)
end
--رloadingHUD
function LoginBaseUI:hideLoadingHUD()
	local manager =UIManager.Instance
	manager:hideLoadingHUD()
end

function LoginBaseUI:addTopLeftNode(node,title,pos)
	if not pos then
		pos = ccp(0,0)
	end
	if not self.topLeftNode then
		self.topLeftNode = CCNode:create()
		self.rootNode:addChild(self.topLeftNode, UIZOrder.TopLeftNode)
		VisibleRect:relativePosition(self.topLeftNode,self.rootNode,LAYOUT_TOP_INSIDE+LAYOUT_LEFT_INSIDE,pos)
	else
		self.topLeftNode:removeAllChildrenWithCleanup(true)
		self.topLeftNode:setPosition(ccp(0,0))
		VisibleRect:relativePosition(self.topLeftNode,self.rootNode,LAYOUT_TOP_INSIDE+LAYOUT_LEFT_INSIDE,pos)
	end
	if node then
		local nodeSize = node:getContentSize()
		self.topLeftNode:addChild(node)
		VisibleRect:relativePosition(node,self.topLeftNode,LAYOUT_LEFT_INSIDE,ccp(-5,-nodeSize.height/2-15))
		if title then
			self.topLeftNode:addChild(title)
			VisibleRect:relativePosition(title,node,LAYOUT_CENTER+LAYOUT_RIGHT_OUTSIDE,ccp(scale*9,0))
			VisibleRect:relativePosition(title,self.topLeftNode,LAYOUT_TOP_INSIDE,ccp(0,-scale*43))
		end
	end
end

function LoginBaseUI:createCloseBtn(layoutPoint)
	self:removeFromRootNode(self.btnClose)
	
	self.btnClose = createButtonWithFramename(RES("login_sr_close.png"), RES("login_sr_close.png"))
	self.btnClose:setTouchAreaDelta(8, 8, 12, 1)
	self.btnClose:setTouchPriority(UIPriority.Control)
	self.rootNode:addChild(self.btnClose, 50)
	if not layoutPoint then
		layoutPoint = ccp(-15, -5)
	end
	local btnCloseSize = self.btnClose:getContentSize()
	VisibleRect:relativePosition(self.btnClose,self.rootNode,LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE, layoutPoint)
	local exitFunction =  function ()
		if self.onCloseBtnClick then
			if self:onCloseBtnClick() ~= false then
				self:close()
			end
		else
			self:close()
		end
	end
	self.btnClose:addTargetWithActionForControlEvents(exitFunction,CCControlEventTouchUpInside)
end

--عرհť
function LoginBaseUI:setVisiableCloseBtn(flag)
	if self.btnClose then
		self.btnClose:setVisible(flag)
	end
end

--дú
function LoginBaseUI:getNodeByName(name)
	return nil
end

function LoginBaseUI:createBackground(size, bgImage, rect)
	self:removeFromRootNode(self.background)
	if (bgImage == nil) then
		bgImage = RES("login_squares_bg1.png")
	end		
	if (rect) then
		self.background = createScale9SpriteWithFrameName(bgImage, rect)
	else
		self.background = createScale9SpriteWithFrameName(bgImage)
	end
	self.background:setPreferredSize(size)
	self.rootNode:addChild(self.background)
	VisibleRect:relativePosition(self.background,self.rootNode,LAYOUT_CENTER)
end

function LoginBaseUI:close()
	local rootNode = self.rootNode
	UIManager.Instance:hideDialog(rootNode)
	
	local ViewName = self.viewName
	UIManager.Instance:hideUI(self.viewName)
end

--رհťʱĻص
function LoginBaseUI:onCloseBtnClick()
	return true
end

function LoginBaseUI:createVipFrame(size, title, offset)
	local frameSize = size
	if size then
		local framewidth = size.width
		if framewidth%2==0 then
			frameSize = CCSizeMake(framewidth+1,size.height)
		end
	else
		return 
	end
	
	self.rootNode:setContentSize(frameSize)
	local viewSize = CCSizeMake(frameSize.width-39*2, frameSize.height-40)
	self.contentNode:setContentSize(viewSize)
	VisibleRect:relativePosition(self.contentNode, self.rootNode, LAYOUT_CENTER_X+LAYOUT_BOTTOM_INSIDE, ccp(0, 0))

	self:makeMeCenter()
	

	offset = offset or ccp(0, 15)

	local bgSize = frameSize
	local dsSize = CCSizeMake(bgSize.width - 60, bgSize.height-40)

	self.dsBG = createScale9SpriteWithFrameNameAndSize(RES("common_sr_bg.png"), dsSize)
	self.rootNode:addChild(self.dsBG)

	self.loginBG = createScale9SpriteWithFrameNameAndSize(RES("common_sr_frame.png"), bgSize)
	self.rootNode:addChild(self.loginBG, 2)

	-- local cLeft = createSpriteWithFrameName(RES("common_bianjian.png"))
	-- self.loginBG:addChild(cLeft)
	-- local rLeft = createSpriteWithFrameName(RES("common_bianjian.png"))
	-- self.loginBG:addChild(rLeft)
	-- rLeft:setFlipX(true)

	-- VisibleRect:relativePosition(cLeft, self.loginBG, LAYOUT_TOP_INSIDE + LAYOUT_LEFT_OUTSIDE, ccp(22, 9))
	-- VisibleRect:relativePosition(rLeft, self.loginBG, LAYOUT_TOP_INSIDE + LAYOUT_RIGHT_OUTSIDE, ccp(-21, 9))

	VisibleRect:relativePosition(self.dsBG, self.rootNode, LAYOUT_CENTER_X+LAYOUT_BOTTOM_INSIDE, offset)
	VisibleRect:relativePosition(self.loginBG, self.dsBG, LAYOUT_CENTER_X+LAYOUT_BOTTOM_INSIDE,ccp(0,-10))


	if title then
		self.rootNode:addChild(title, 2)
		VisibleRect:relativePosition(title, self.dsBG, LAYOUT_CENTER_X+LAYOUT_TOP_INSIDE, ccp(0, 20))
	end		
end

function LoginBaseUI:createVipFrameCloseBtn(btntype,func,pos)

	self.btnVipCloseBtn = createButtonWithFramename(RES("common_sr_close.png"))
	
	
	if self.btnVipCloseBtn then	
		self.rootNode:addChild(self.btnVipCloseBtn, 50)	
		
		local offsetPos = ccp(0, 0)
		if pos then
			offsetPos = pos
		end	
		VisibleRect:relativePosition(self.btnVipCloseBtn, self.rootNode, LAYOUT_TOP_INSIDE+LAYOUT_RIGHT_INSIDE,offsetPos)

		local exitFunction = function ()
			if func then
				func()
			else
				self:close()
			end
		end
		self.btnVipCloseBtn:addTargetWithActionForControlEvents(exitFunction,CCControlEventTouchUpInside)
	end
end

--Ĭϵinit
function LoginBaseUI:myInit(size, pos)
	
	local viewSize
	if size then
		viewSize = CCSizeMake(size.width*scale,size.height*scale)
	else
		viewSize = visibleSize
	end 
	self.rootNode:setContentSize(viewSize)

	self:updateContentNode()

	if pos then
		self.rootNode:setPosition(pos)
	else
		self:makeMeCenter()
	end
	 
	self:myCreateBackground(viewSize,nil,CCRectMake(250,120,1,1))
	self:myCreateBgDi()
	self:myCreateCloseBtn()

	--self:myCreateBottomCorner()
	
	if _DEBUG_MODE and self.enableReload then
		local btnReload = createButtonWithFramename(RES("common_sr_close.png"), RES("common_sr_close.png"))
		btnReload:setColor(ccc3(0, 255, 0))
		self.rootNode:addChild(btnReload)
		VisibleRect:relativePosition(btnReload,self.btnClose,LAYOUT_LEFT_OUTSIDE+LAYOUT_CENTER_Y,ccp(-15,0))
		--VisibleRect:relativePosition(btnReload,self.background,LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-20,-20))
		local reloadFunction = function ()
			self:reload()
			print("current UI reload")
		end
		btnReload:addTargetWithActionForControlEvents(reloadFunction,CCControlEventTouchDown)

	    -- local function KeypadHandler(strEvent)
	    -- 	if "backClicked" == strEvent then
	    -- 		self:reload()
	    -- 	elseif "menuClicked" == strEvent then
	    -- 	end
	    -- end
	    -- self.rootNode:setKeypadEnabled(true)
	    -- self.rootNode:registerScriptKeypadHandler(KeypadHandler)
	end
end

function LoginBaseUI:myCreateBackground(size, bgImage, rect)
	self:removeFromRootNode(self.background)
	if (bgImage == nil) then
		bgImage = RES("squares_bg1.png")--RES("squares_bg1.png") com_kuang_ui
	end		
	if (rect) then
		self.background = createScale9SpriteWithFrameName(bgImage, rect)
		--self.bg_di		= createScale9SpriteWithFrameName(RES("com_scale_ui_di.png"),rect)
	else
		self.background = createScale9SpriteWithFrameName(bgImage)
		--self.bg_di		= createScale9SpriteWithFrameName(RES("com_scale_ui_di.png"),rect)
	end
	self.background:setContentSize(size)
	self.rootNode:addChild(self.background)
	--self.background:setVisible(false)
	VisibleRect:relativePosition(self.background,self.rootNode,LAYOUT_CENTER)
end

function LoginBaseUI:myCreateBgDi(offsetx,offsety,width,height,image)
	-- body
	local x = offsetx or 58
	local y = offsety or -55
	local iWidth = width or self.rootNode:getContentSize().width-2*x
	local iHeight = height or self.rootNode:getContentSize().height+y-5
	local iImage = image or "common_dishe.png"


	self:removeFromRootNode(self.bg_di)
	self.bg_di = createScale9SpriteWithFrameName(RES(iImage),CCRectMake(1,1,1,1))
	local rect = CCRectMake(0,0,iWidth,iHeight)
	self.bg_di:setContentSize(CCSizeMake(iWidth,iHeight))
	self.rootNode:addChild(self.bg_di,-1)
	VisibleRect:relativePosition(self.bg_di, self.rootNode, LAYOUT_LEFT_INSIDE + LAYOUT_TOP_INSIDE, ccp(x,y))
end

function LoginBaseUI:myCreateBottomDi(size,offset)
	-- body
	-- һ CCSizeMake(395,95),ccp(30,20)


	local size = size or CCSizeMake(self.rootNode:getContentSize().width-120,82)
	local offset = offset or ccp(59, 26)

	local bottomBg = createSpriteWithFrameName(RES("role_di.png"),size)
	self.rootNode:addChild(bottomBg,-1)
	
	--bottomBg:setTextureRect(CCRectMake(0,0,size.width,size.height))
	VisibleRect:relativePosition(bottomBg, self.rootNode, LAYOUT_LEFT_INSIDE + LAYOUT_BOTTOM_INSIDE,offset )
	gAddColorLayer(self.rootNode)
	-- local leftSprite = createSpriteWithFrameName(RES("common_bian.png"))
	-- self.rootNode:addChild(leftSprite,3)
	-- VisibleRect:relativePosition(leftSprite, bottomBg, LAYOUT_LEFT_INSIDE + LAYOUT_BOTTOM_INSIDE, ccp(0, 0))

	-- local rightSprite = createSpriteWithFrameName(RES("common_bian.png"))
	-- self.rootNode:addChild(rightSprite,3)
	-- rightSprite:setFlipX(true)
	-- VisibleRect:relativePosition(rightSprite, bottomBg, LAYOUT_RIGHT_INSIDE + LAYOUT_BOTTOM_INSIDE, ccp(2, 0))
	return bottomBg
end

function LoginBaseUI:myCreateCloseBtn(layoutPoint)
	if self.btnClose then
		self:removeFromRootNode(self.btnClose)
		self.btnClose = nil
	end
	
	self.btnClose = createButtonWithFramename(RES("common_sr_close.png"), RES("common_sr_close.png"))
	if not self.btnClose then
		CCLuaLog("LoginBaseUI:createCloseBtn error. create failed.")
		return
	end
	self.btnClose:setTouchAreaDelta(8, 8, 12, 1)
	self.btnClose:setTouchPriority(UIPriority.Control)
	self.rootNode:addChild(self.btnClose, 50)
	if not layoutPoint then
		layoutPoint = ccp(-30, -5)
	end
	local btnCloseSize = self.btnClose:getContentSize()
	VisibleRect:relativePosition(self.btnClose,self.rootNode,LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE, layoutPoint)
	local function exitFunction()
		if self.onCloseBtnClick then
			if self:onCloseBtnClick() ~= false then
				self:close()
			end
		else
			self:close()
		end
	end
	self.btnClose:addTargetWithActionForControlEvents(exitFunction,CCControlEventTouchDown)
end

--ֱӦͬ򱳾
function LoginBaseUI:myCreateBottomCorner(idx)

	local data = {
		com_kuang_ui = ccp(58,17),
		common_biankuang = ccp(25,17),
	}


	local idx = idx or "com_kuang_ui"
	local offset = data[idx]


	local corner = createSpriteWithFrameName(RES("common_dibianjiao.png"))
	self.rootNode:addChild(corner,50)
	VisibleRect:relativePosition(
				corner, 
				self.rootNode,
			 	LAYOUT_LEFT_INSIDE+LAYOUT_BOTTOM_INSIDE,
			 	ccp(offset.x, offset.y))

	local corner2 = createSpriteWithFrameName(RES("common_dibianjiao.png"))
	self.rootNode:addChild(corner2,50)
	corner2:setFlipX(true)
	VisibleRect:relativePosition(
				corner2, 
				self.rootNode,
			 	LAYOUT_RIGHT_INSIDE+LAYOUT_BOTTOM_INSIDE,
			 	ccp(-offset.x, offset.y))
end


--ɢ˴¼-----
function LoginBaseUI:initDebug()
	if _DEBUG_MODE then
		local btnReload = createButtonWithFramename(RES("common_sr_close.png"), RES("common_sr_close.png"))
		btnReload:setColor(ccc3(0, 255, 0))
		self.rootNode:addChild(btnReload)
		VisibleRect:relativePosition(btnReload,self.btnClose,LAYOUT_LEFT_OUTSIDE+LAYOUT_CENTER_Y,ccp(-15,0))
		--VisibleRect:relativePosition(btnReload,self.background,LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-20,-20))
		local reloadFunction = function ()
			self:reload()
			print("current UI reload")
		end
		btnReload:addTargetWithActionForControlEvents(reloadFunction,CCControlEventTouchDown)

	end
end

function LoginBaseUI:srInit(size, pos)
	
	local viewSize
	if size then
		viewSize = CCSizeMake(size.width*scale,size.height*scale)
	else
		viewSize = visibleSize
	end
	
	self.rootNode:setContentSize(viewSize)


	self.offset = ccp(30,-68)
	self.contentNodeOffsety = 20 -- contentnoderootnodeڵײƫ

	local contentSize = CCSizeMake(self.rootNode:getContentSize().width-self.offset.x*2, self.rootNode:getContentSize().height+self.offset.y-self.contentNodeOffsety)
	self.contentNode:setContentSize(contentSize)
	VisibleRect:relativePosition(self.contentNode, self.rootNode, LAYOUT_LEFT_INSIDE + LAYOUT_TOP_INSIDE, self.offset)	
	
	if pos then
	else
		self:makeMeCenter()
	end
	
	--
	self.frameOutside = createScale9SpriteWithFrameNameAndSize(RES("login_sr_frame.png"), size, CCRectMake(120,90,180,102))	
	self.rootNode:addChild(self.frameOutside)
	VisibleRect:relativePosition(self.frameOutside,self.rootNode,LAYOUT_CENTER)

	--ڿͼ
	self.bgInside = createSpriteWithFrameName(RES("login_sr_big_bg.png"),
		 CCSizeMake(contentSize.width , contentSize.height))
	self.rootNode:addChild(self.bgInside)
	VisibleRect:relativePosition(self.bgInside,self.rootNode,LAYOUT_CENTER,ccp(0,-23))

	-- رհť
	self:createCloseBtn()
	
	self:initDebug()
end