require("ui.UIManager")
require("common.LoginBaseUI")

GetServerListHUDView = GetServerListHUDView or BaseClass(LoginBaseUI)
local visibleSize = CCDirector:sharedDirector():getVisibleSize()
local const_scale = VisibleRect:SFGetScale()

function GetServerListHUDView:__init()
	self.viewName = "GetServerListHUDView"
	self:createRootNode()
	self:showVersion()
	self:createContanctRichText()

	if SFGameConfig:getInstance():getQDCode2() == 30001 then--30001ʾios 	
		self:showIosTips()
	end
end	

function GetServerListHUDView:create()
	return GetServerListHUDView.New()
end

function GetServerListHUDView:onEnter()	
	if  LoginWorld.Instance:getLoginManager():getIsOverSeasSDK() then
		self:showOverSeasContanctText()
	end
end

function GetServerListHUDView:__delete()
	if self.richLabel then 
		self.richLabel:release()
		self.richLabel = nil
	end

	if self.watingScheduleID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.watingScheduleID)
		self.watingScheduleID = nil
	end

	if self.loginScheduleID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.loginScheduleID)
		self.loginScheduleID = nil
	end
end

function GetServerListHUDView:createContanctRichText()	
	if not self.richLabel then
		self.richLabel= createRichLabel(CCSizeMake(0,0))
		self.richLabel:setGaps(0)
		self.richLabel:setFontSize(FSIZE("Size4"))
		self.richLabel:retain()			
		self.rootNode:addChild(self.richLabel)	
		VisibleRect:relativePosition(self.richLabel,self.rootNode,LAYOUT_BOTTOM_INSIDE + LAYOUT_RIGHT_INSIDE,ccp(-60,40))		
	end
	local richLabelHandler = function(arg, pTouch)	
		local touch = tolua.cast(pTouch, "CCTouch")
		local pos = touch:getLocation()	
		local email_Url = SFGameConfig:getInstance():getStringConfig("Service_Email")
		local title = Config.LoginWords[10517]
		local content = Config.LoginWords[10525] .. "\n\n\n\n"
		LoginWorld.Instance:getStatisticsMgr():sendEmail(email_Url,title,content)
	end
	self.richLabel:setEventHandler(richLabelHandler)
end

function GetServerListHUDView:showOverSeasContanctText()	
	if  self.richLabel then
		self.richLabel:clearAll()
		local richText = string.wrapHyperLinkRich(Config.LoginWords[1043],Config.FontColor["ColorRed1"],FSIZE("Size3"),"sendMail", "true") 
		self.richLabel:appendFormatText(richText)
		self.richLabel:setTouchEnabled(true)
		VisibleRect:relativePosition(self.richLabel,self.rootNode,LAYOUT_BOTTOM_INSIDE + LAYOUT_RIGHT_INSIDE,ccp(-60,40))		
	end
end	

function GetServerListHUDView:createRootNode()
	self:makeMeCenter()
	--Logo	
	local Logo 
	if SFGameConfig:getInstance():getQDCode2() == 20001 then
		Logo =  CCScale9Sprite:create("loginUi/login/loading_sbk.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --
		Logo =  CCScale9Sprite:create("loginUi/login/loading_jz.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then --ս
		Logo =  CCScale9Sprite:create("loginUi/login/loading_jz.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then --
		Logo =  CCScale9Sprite:create("loginUi/login/loading_zm.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then --ȫ
		Logo =  CCScale9Sprite:create("loginUi/login/loading_jz.jpg")
	else
		Logo =  CCScale9Sprite:create("loginUi/login/loading.jpg")
	end
	
	local gameWarning = createSpriteWithFileName("loginUi/login/gameWarning.png")
	self.rootNode:addChild(Logo)
	self.rootNode:addChild(gameWarning)
	--G_setScale(Logo)
	G_setBigScale(Logo)
	
	self.loadingNode = CCNode:create()
	self.loadingNode:setContentSize(self.rootNode:getContentSize())
	VisibleRect:relativePosition(self.loadingNode,self.rootNode,LAYOUT_CENTER)
	self.rootNode:addChild(self.loadingNode)
	--Label
	self.textTips = CCLabelTTF:create("", "Arial", 30)
	self.loadingNode:addChild(self.textTips)
	--G_setScale(self.textTips)
	--תȦ
	local CircleSprite = createSpriteWithFrameName(RES("login_loading.png"))
	self.loadingNode:addChild(CircleSprite)
	G_setScale(CircleSprite)
	--ת
	local Rotate = CCRotateBy:create(1.0, 360)
	local RotateForever = CCRepeatForever:create(Rotate)
	CircleSprite:runAction(RotateForever)
	SimpleAudioEngine:sharedEngine():stopBackgroundMusic()
	SimpleAudioEngine:sharedEngine():playBackgroundMusic("music/login.mp3")		
	VisibleRect:relativePosition(Logo, self.rootNode, LAYOUT_CENTER)
	VisibleRect:relativePosition(gameWarning, self.rootNode, LAYOUT_CENTER+LAYOUT_BOTTOM_INSIDE,ccp(0,20))
	VisibleRect:relativePosition(self.textTips, self.rootNode, LAYOUT_CENTER,ccp(0,-50))
	VisibleRect:relativePosition(CircleSprite, self.rootNode, LAYOUT_CENTER, ccp(0, -150))
end

-- ʾϷʼʾϢ
function GetServerListHUDView:startInit()
	self.textTips:setString(Config.LoginWords[345])
	VisibleRect:relativePosition(textTips, self.rootNode, LAYOUT_CENTER,ccp(0,-50))
	self.loadingNode:setVisible(true)
	if self.btnEnterGame then
		self.btnEnterGame:setVisible(false)
	end
end

-- ʵֻȡбʾϢ
function GetServerListHUDView:startGetServerList()
	self.textTips:setString(Config.LoginWords[334])
	VisibleRect:relativePosition(textTips, self.rootNode, LAYOUT_CENTER,ccp(0,-50))
	self.loadingNode:setVisible(true)
	if self.btnEnterGame then
		self.btnEnterGame:setVisible(false)
	end
end

--ȡ
function GetServerListHUDView:getServerList(errCode)
	if errCode == ServerListCode.Success then
		-- ֹͣתȦ
		self.loadingNode:setVisible(false)

		-- ʾ¼ť		
		if not self.btnEnterGame then
			self.btnEnterGame = createButtonWithFramename(RES("role_loginBtn.png"), RES("role_loginBtn.png"))
			self:addChild(self.btnEnterGame)
			VisibleRect:relativePosition(self.btnEnterGame, self:getContentNode(), LAYOUT_CENTER,ccp(0,-170))	
			
			local function LoginConnect()
				--iprint("LoginConnect ")
				self:showWating()
				LoginWorld.Instance:getLoginManager():requestLogin()
			end

			self.btnEnterGame:addTargetWithActionForControlEvents(LoginConnect,CCControlEventTouchDown)	
		else
			self.btnEnterGame:setVisible(true)
		end
		
		-- Ϊ˱sdk˸, 0.3Sȥ¼	
		local function scheduleCallback(time)
			self:showWating()

			if self.loginScheduleID then
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.loginScheduleID)
				self.loginScheduleID = nil
			end
			LoginWorld.Instance:getLoginManager():requestLogin()
		end
			
		self.loginScheduleID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(scheduleCallback, 0.3, false)
	else
		self.loadingNode:setVisible(state)
		
		if errCode == ServerListCode.NetworkError then
			self:showGetServerListFail()
		else
			self:showServerListDataError()
		end
	end
end

function GetServerListHUDView:reGetServerList()
	self.loadingNode:setVisible(true)
	LoginWorld.Instance:getLoginManager():requestServerList()--б		
end

function GetServerListHUDView:showServerListDataError()
	local reGetFunc = function(arg,text,id)		
		if id == 0 then	
			self:reGetServerList()
		else
			os.exit(0)
		end	
	end
	local btns ={
		{text = Config.LoginWords[344],	id = 1},
		{text = Config.LoginWords[340],	id = 0},
	}

	local msg = showMsgBox(Config.LoginWords[358])
	msg:setBtns(btns)
	msg:setNotify(reGetFunc)
end

function GetServerListHUDView:showGetServerListFail()
	local reGetFunc = function(arg,text,id)		
		if id == 0 then	
			self:reGetServerList()
		else
			os.exit(0)
		end	
	end
	local btns ={
		{text = Config.LoginWords[344],	id = 1},
		{text = Config.LoginWords[340],	id = 0},
	}

	local msg = showMsgBox(Config.LoginWords[339])
	msg:setBtns(btns)
	msg:setNotify(reGetFunc)
end

function GetServerListHUDView:showVersion()
	local clientLb = createLabelWithStringFontSizeColorAndDimension(Config.LoginWords[332],"Arial", FSIZE("Size2"), FCOLOR("ColorWhite1"))	
	local verLb = createLabelWithStringFontSizeColorAndDimension(Config.LoginWords[333],"Arial", FSIZE("Size2"), FCOLOR("ColorWhite1"))	
	local clientVer = SFGameHelper:getClientVersion()	
	local resVer = "0.0.0"
	local baseVersion = ResManager.Instance:getPackVersion("base.zpk")	
	
	--iprint("baseVersion:",baseVersion)

	--baseexternСһֵ
	if baseVersion ~= "0.0.0" then
		local extendVersion = ResManager.Instance:getPackVersion("extend.zpk")
		if extendVersion ~= "0.0.0" then
			if ResManager.Instance:compareVersion(baseVersion, extendVersion)==true then
				resVer = extendVersion
			else
				resVer = baseVersion
			end
		end
	end		
	self.clientVerLb = createLabelWithStringFontSizeColorAndDimension(clientVer,"Arial", FSIZE("Size2"), FCOLOR("ColorWhite1"))	
	self.resVerLb = createLabelWithStringFontSizeColorAndDimension(resVer,"Arial", FSIZE("Size2"), FCOLOR("ColorWhite1"))
	self.rootNode:addChild(clientLb)
	self.rootNode:addChild(verLb)	
	self.rootNode:addChild(self.clientVerLb)
	self.rootNode:addChild(self.resVerLb)
	VisibleRect:relativePosition(clientLb,self.rootNode,LAYOUT_BOTTOM_INSIDE+LAYOUT_RIGHT_INSIDE,ccp(-80,20))
	VisibleRect:relativePosition(verLb,clientLb,LAYOUT_BOTTOM_OUTSIDE+LAYOUT_RIGHT_INSIDE,ccp(0,0))
	VisibleRect:relativePosition(self.clientVerLb,clientLb,LAYOUT_CENTER+LAYOUT_RIGHT_OUTSIDE,ccp(0,0))
	VisibleRect:relativePosition(self.resVerLb,verLb,LAYOUT_CENTER+LAYOUT_RIGHT_OUTSIDE,ccp(0,0))
	
	if needReadAppResources() then
		ResManager.Instance:releaseZpk()
	end
end

function GetServerListHUDView:showIosTips()

	local bg = createScale9SpriteWithFrameNameAndSize(RES("login_sr_text_bg.png"),CCSizeMake(420,90))
	self.rootNode:addChild(bg)
	VisibleRect:relativePosition(bg,self.rootNode,LAYOUT_CENTER_X+LAYOUT_TOP_INSIDE,ccp(0,-50))
	-- body
	local iosTips = createLabelWithStringFontSizeColorAndDimension(Config.LoginWords[20100],"Arial", FSIZE("Size2"), FCOLOR("ColorWhite1"),CCSizeMake(400,72))	
	bg:addChild(iosTips)
	VisibleRect:relativePosition(iosTips,bg,LAYOUT_CENTER,ccp(0,5))
	

end

--תȦȦ
function GetServerListHUDView:showWating()

	--ʼ
	if not self.wating then
		self.wating = createSpriteWithFrameName(RES("login_loading.png"))
		self.rootNode:addChild(self.wating)
		G_setScale(self.wating)
		--ת
		local Rotate = CCRotateBy:create(1.0, 360)
		local RotateForever = CCRepeatForever:create(Rotate)
		self.wating:runAction(RotateForever)
		VisibleRect:relativePosition(self.wating, self.rootNode, LAYOUT_CENTER, ccp(0, 0))
	else
		self.wating:setVisible(true)
	end

	local function scheduleCallback(time)
		self.wating:setVisible(false)
		self.btnEnterGame:setVisible(true)

		if self.watingScheduleID then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.watingScheduleID)
			self.watingScheduleID = nil
		end
	end
			
	self.watingScheduleID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(scheduleCallback, 15, false)

	if self.btnEnterGame then
		self.btnEnterGame:setVisible(false)
	end
end