require("ui.UIManager")
require("common.LoginBaseUI")

ResourcesUpdateView = ResourcesUpdateView or BaseClass(LoginBaseUI)
local visibleSize = CCDirector:sharedDirector():getVisibleSize()
local const_scale = VisibleRect:SFGetScale()
local total = -1
local percentage = 0
local count= 0
local fileName = ""
local maxErrorCount = 3
local lastName = ""
function ResourcesUpdateView:__init()
	self.viewName = "ResourcesUpdateView"
	
	self.fadeIn = 0.2
	self.time = 0.05
	self.errorCount = 0
	self:createRootNode()
	self.errCode = -1
end

function ResourcesUpdateView:__delete()
	self:unschedulePatchEntry()
	self:unscheduleDownloadEntry()
	
	if self.loadSpeed then
		self.loadSpeed:release()
		self.loadSpeed = nil
	end
	if self.currentRate then
		self.currentRate:release()
		self.currentRate = nil
	end
	self.nameLabel = nil
	self.UpdateSpriteWhite2BG = nil
end

function ResourcesUpdateView:create()
	return ResourcesUpdateView.New()
end

function ResourcesUpdateView:setSpeed(str)
	if type(str) == "string" and self.loadSpeed then
		self.loadSpeed:setString(str)
	end
end

function ResourcesUpdateView:setProgress(str)
	if type(str) == "string" and self.currentRate then
		self.currentRate:setString(str)
	end
end

function ResourcesUpdateView:createRootNode()
	self:makeMeCenter()

	local colorBg 

	--login_loading_bg_sbk ͼûϷֵlogoģԺеͼ
	if SFGameConfig:getInstance():getQDCode2() == 20001 then
		colorBg = createSpriteWithFrameName(RES("login_loading_bg_sbk.png"))
	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --
		colorBg = createSpriteWithFrameName(RES("login_loading_bg_sbk.png"))
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then
		colorBg = createSpriteWithFrameName(RES("login_loading_bg_sbk.png"))
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then
		colorBg = createSpriteWithFrameName(RES("login_loading_bg_sbk.png"))
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then
		colorBg = createSpriteWithFrameName(RES("login_loading_bg_sbk.png"))
	else
		colorBg = createSpriteWithFrameName(RES("login_loading_bg.png"))
	end

	G_setBigScale(colorBg)
	self.rootNode:addChild(colorBg)
	VisibleRect:relativePosition(colorBg, self.rootNode, LAYOUT_CENTER)
	
	self.currentNum = 0
	self.allNum = 0
	
	--ٶ
	self.loadSpeed = CCLabelTTF:create(" ", "Arial", 15)
	self.loadSpeed:retain()
	self.rootNode:addChild(self.loadSpeed)
	VisibleRect:relativePosition(self.loadSpeed, self.rootNode, LAYOUT_CENTER,ccp(200,-220))
	
	--ǰ
	self.currentRate = CCLabelTTF:create(" ", "Arial", 15)
	self.currentRate:retain()
	self.rootNode:addChild(self.currentRate)
	VisibleRect:relativePosition(self.currentRate, self.rootNode, LAYOUT_CENTER,ccp(200,-280))
	
	self.downloadProgress = createProgressBar(RES("login_progress_bg.png")
			,RES("login_progress_bar.png"),CCSizeMake(660,20))
	self.downloadProgress:setPercentage(0)	
	self.downloadProgress:setMaxNumber(100)
	self.downloadProgress:setNumberVisible(false)	
	self.rootNode:addChild(self.downloadProgress)
	VisibleRect:relativePosition(self.downloadProgress, self.rootNode, LAYOUT_CENTER,ccp(0,-250))
	
	self.nameLabel = createLabelWithStringFontSizeColorAndDimension("","Arial",FSIZE("Size3"), FCOLOR("ColorWhite1"))
	self.rootNode:addChild(self.nameLabel)	
	--VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER, ccp(0,-150))

	self.progressFrame = createScale9SpriteWithFrameNameAndSize(RES("login_progress_frame.png")
		,CCSizeMake(740,41),CCRectMake(90,21,1,1))
	self.downloadProgress:addChild(self.progressFrame,10)	
	VisibleRect:relativePosition(self.progressFrame, self.downloadProgress, LAYOUT_CENTER, ccp(0,-1))

	self.light = createSpriteWithFrameName(RES("login_progress_light.png"))
	self.downloadProgress:addChild(self.light,11)	
	VisibleRect:relativePosition(self.light, self.downloadProgress
		, LAYOUT_LEFT_INSIDE+LAYOUT_CENTER_Y, ccp(-100 + (660 * 0 / 100) ,0))
end

function ResourcesUpdateView:onEnter()
	self:setSpeed("")
	self:setProgress(Config.LoginWords[14011].."0%")
end

function ResourcesUpdateView:startDownload(urlList,func)
	percentage = 0
	fileName = ""
	self.dowloadSpeed = 0
	self.finish = false
	self.dowloadError = false
	local function tick()
		if self.dowloadError then
			self:unscheduleDownloadEntry()
			DownloadManager.Instance:stop()
			self:showDownloadErrorNotify(urlList,func)
			self.dowloadError  = false
		else
			if self.finish then
				self:unscheduleDownloadEntry()
				self:setProgress(Config.LoginWords[14011].."100%")
				DownloadManager.Instance:stop()
				self.finish = false
				self.downloadProgress:setPercentage(100)
				VisibleRect:relativePosition(self.light, self.downloadProgress
					, LAYOUT_LEFT_INSIDE+LAYOUT_CENTER_Y, ccp(-100 + (660 * 100 / 100) ,0))
				
				if func then
					func()
				end
				local function callback(list)
					self:delayFunc(list)
				end
				DownloadManager.Instance:moveDownloadedFile(callback)
			else
				self.dowloadSpeed = string.format("%.2f",self.dowloadSpeed)
				local showingTitle = self.dowloadSpeed.."kb/s"
				self:setSpeed(showingTitle)
				percentage = math.ceil(percentage)
				self:setProgress(Config.LoginWords[14011]..percentage.."%")
				self:setCurrentNumAndAllNum(fileName,percentage,total)

				VisibleRect:relativePosition(self.light, self.downloadProgress
					, LAYOUT_LEFT_INSIDE+LAYOUT_CENTER_Y, ccp(-100 + (660 * percentage / 100) ,0))
				self.downloadProgress:setCurrentNumber(percentage)
			end
		end
	end
	
	local function downloadCallBack(eventCode, intValue, stringData, doubleValue)
		self:handleDownloadDelegate(eventCode, intValue, stringData, doubleValue)
	end
	
	ResManager.Instance:startDownload(downloadCallBack)
	self:unscheduleDownloadEntry()
	self.tickid = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(tick, 1, false)
end

function ResourcesUpdateView:delayFunc(list)
	local function delayFunc()
		local size = table.size(list)
		if size > 0 then
			ResManager.Instance:reloadZpk(list)
			if ResManager.Instance:checkResVersion() == true then
				local serverMgr = LoginWorld.Instance:getServerMgr()
				local selectServer = serverMgr:getSelectServer()
				ResManager.Instance:requestUpdateRes(selectServer:getServerId(),nil, nil, eHttpReqTag.ResUpdateTag)
			else
				GlobalEventSystem:Fire(GameEvent.EVENT_SELECTSIGNSERVER_UI)
			end
		else
			CCLuaLog("delayFunc:".."patch event")
			GlobalEventSystem:Fire(GameEvent.EventPatch,DownloadManager.Instance:getDownloadList())
		end
	end
	UIManager.Instance:showLoadingHUD(1.5,nil,delayFunc)
end

function ResourcesUpdateView:showDownloadErrorNotify(dowloadList,func)
	-- Ĵ
	local networkError = function ()
		local downloadErrorNotice = function(arg,text,id)
			if id == 0 then
				self:startDownload(dowloadList,func)
			else
				GlobalEventSystem:Fire(GameEvent.EVENT_SELECTSIGNSERVER_UI)
			end
		end
		local btns ={
		{text = Config.LoginWords[10043], id = 0},
		{text = Config.LoginWords[10045], id = 1},
		}
		local notic = Config.LoginWords[14001]
		if self.errorCount == maxErrorCount then
			btns = {
			{text = Config.LoginWords[10043], id = 0},
			}
			notic = Config.LoginWords[14002]
			downloadErrorNotice = function ()
				GlobalEventSystem:Fire(GameEvent.EVENT_SELECTSIGNSERVER_UI)
			end
			self.errorCount = 0
		end
		local msg = showMsgBox(notic)
		msg:setBtns(btns)
		msg:setNotify(downloadErrorNotice)
	end
	
	local spaceError = function ()
		local clickCallback = function ()
			GlobalEventSystem:Fire(GameEvent.EVENT_SELECTSIGNSERVER_UI)
		end
		local msg = showMsgBox(Config.LoginWords[354]..Config.LoginWords[356])
		msg:setNotify(clickCallback)
	end
	
	if self.errCode == kCreateFile then
		spaceError()
	else
		networkError()
	end
end

function ResourcesUpdateView:unschedulePatchEntry()
	if self.patchTickid then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.patchTickid)
		self.patchTickid = nil
	end
end

function ResourcesUpdateView:unscheduleDownloadEntry()
	if self.tickid then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.tickid)
		self.tickid = nil
	end
end

function ResourcesUpdateView:startPatch(patchList, callback)
	if self.nameLabel then
		self.nameLabel:setString(" ")
	end
	percentage = 0
	self.current = 0
	self.total = 0
	self.patchFinish = false
	self.patchError = false
	local function patchTick()
		if self.patchError == true then
			self.patchError = false
		end


		if self.patchFinish then
			self:setProgress(Config.LoginWords[14011].."100%")
			
			self.patchFinish = false
			local function completeFunc()
				local schId
				local function onTimeout()
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(schId)
					GlobalEventSystem:Fire(GameEvent.EVENT_SELECTSIGNSERVER_UI)
				end
				schId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimeout, 1, false)
			end
			
			if callback then
				PatchManager.Instance:complete(callback)
			else
				PatchManager.Instance:complete(completeFunc)
			end
		else
			if self.current ~= 0 and self.total ~= 0 then
				local showString = self.current.." / "..self.total
				percentage = self.current/self.total*100
				percentage = math.ceil(percentage)
				self:setProgress(Config.LoginWords[14011]..percentage.."%")

			end
		end

		


	end
	local function patchCallback(eventCode,errorCode,current,total)
		self:handlePatchDelegate(eventCode,errorCode,current,total)
	end
	
	local manager = PatchManager.Instance
	manager:registerCallBack(patchCallback)
	manager:startPatch(patchList)
	self:unschedulePatchEntry()
	self.patchTickid = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(patchTick, 0.2, false)
end

function ResourcesUpdateView:handlePatchDelegate(eventCode,errorCode,current,total)
	if eventCode == eOnPatchProgress then
		self.current = current
		self.total = total

		-- self.downloadProgress:setPercentage(self.current)
		-- VisibleRect:relativePosition(self.light, self.downloadProgress
		-- , LAYOUT_LEFT_INSIDE+LAYOUT_CENTER_Y, ccp(-80 + (460 * self.current / 100) ,0))

	elseif eventCode == eOnSuccess then
		self.patchFinish = true
	elseif eventCode == eOnError then
		self.patchError = true
	end
end

function ResourcesUpdateView:handleDownloadDelegate(eventCode, intValue, stringData, doubleValue)
	
	if eventCode == kOnDownloadSpeed then
		self.dowloadSpeed = string.format("%.2f",doubleValue)
	elseif eventCode == kOnError then
		-- errCode
		self.errCode = intValue
		self.dowloadError = true
		iprint("download error:",kOnError)
		
		if self.errCode ~= kCreateFile then
			-- ռ䲻㲻ҪerrorCount
			self.errorCount = self.errorCount + 1
		end
	elseif eventCode == kOnProgress then
		if total ~= -1 then
			percentage = intValue/total*100
		end
		percentage = math.ceil(percentage)
	elseif eventCode == kOnFilesize then
		fileName = stringData
	elseif eventCode == kOnAllFilesSize then
		total = intValue
	elseif eventCode == kOnSuccess then
		if fileName == "" then
			fileName = stringData
		end
	elseif eventCode == kOnComplete then
		self.finish = true
	end
end

function ResourcesUpdateView:setCurrentNumAndAllNum(currentNum, allNum,size)
	if allNum then
		self:setProgress(Config.LoginWords[14011]..allNum.."%")
	end
	if currentNum and lastName ~= currentNum then
		if self.nameLabel then
			self.nameLabel:setString(currentNum)						
			VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER, ccp(0, -220))					
		end
		lastName = currentNum
	end
end
