ServerItemNode = ServerItemNode or BaseClass()

ServerItemType = {
ServerList = 1,       -- б
ServerArea = 2,       -- 
ServerRecent = 3,     -- ¼
ServerRecommend = 4,  -- Ƽ
}

local ItemConfig = {
[ServerItemType.ServerList]      = {nodeSize=CCSizeMake(280, 68)},
[ServerItemType.ServerArea]      = {nodeSize=CCSizeMake(206, 68)},
[ServerItemType.ServerRecent]    = {nodeSize=CCSizeMake(206, 68)},
[ServerItemType.ServerRecommend] = {nodeSize=CCSizeMake(206, 68)},
}


function ServerItemNode:__init(serverType, hasBg)
	local Def_FontSize = FSIZE("Size5")
	local Def_FontColor = FCOLOR("ColorWhite1")

	self.LabelConfig = {
	[ServerItemType.ServerList] = {
	["name"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --
	["state"] = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --״̬
	["role"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --ɫ
	},
	[ServerItemType.ServerArea] = {
	["name"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --
	["state"] = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --״̬
	["role"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --ɫ
	},
	[ServerItemType.ServerRecent] = {
	["name"]  = {fontSize=FSIZE("Size3"),fontColor=Def_FontColor},   --
	["state"] = {fontSize=FSIZE("Size3"),fontColor=Def_FontColor},   --״̬
	["role"]  = {fontSize=FSIZE("Size3"),fontColor=Def_FontColor},   --ɫ
	},
	[ServerItemType.ServerRecommend] = {
	["name"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --
	["state"] = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --״̬
	["role"]  = {fontSize=Def_FontSize,fontColor=Def_FontColor},   --ɫ
	},
	}
	
	if serverType and ItemConfig[serverType] then 
		self.type = serverType
		self:createRootNode(serverType, hasBg)
		self:createUI(serverType)
	end
end

function ServerItemNode:__delete()
	
end

function ServerItemNode:createRootNode(serverType, hasBg)
	if serverType and ItemConfig[serverType] then 
		local size = ItemConfig[serverType].nodeSize
		self.rootNode = CCNode:create()		
		self.rootNode:setContentSize(size)	
		if hasBg then 
			local nodeBg = createScale9SpriteWithFrameNameAndSize(RES("ui_serverlist_btn_select.png"), size)
			self.rootNode:addChild(nodeBg)
			VisibleRect:relativePosition(nodeBg, self.rootNode, LAYOUT_CENTER)
		end
	end		
end

function ServerItemNode:getRootNode()
	return self.rootNode
end

function ServerItemNode:createUI(serverType)
	if not serverType then 
		return
	end
	if serverType == ServerItemType.ServerList then 
		self.nameLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[ServerItemType.ServerList]["name"].fontSize, self.LabelConfig[ServerItemType.ServerList]["name"].fontColor)
		self.stateLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[ServerItemType.ServerList]["state"].fontSize, self.LabelConfig[ServerItemType.ServerList]["state"].fontColor)		
		self.rootNode:addChild(self.nameLabel)		
		self.rootNode:addChild(self.stateLabel)		
		VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp(10, 0))		
		VisibleRect:relativePosition(self.stateLabel, self.nameLabel, LAYOUT_TOP_INSIDE+LAYOUT_RIGHT_INSIDE, ccp(-20, -10))
	elseif serverType == ServerItemType.ServerRecent then 
		self.nameLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[ServerItemType.ServerRecent]["name"].fontSize, self.LabelConfig[ServerItemType.ServerRecent]["name"].fontColor)
		self.stateLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[ServerItemType.ServerRecent]["state"].fontSize, self.LabelConfig[ServerItemType.ServerRecent]["state"].fontColor)		
		self.roleCntLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[ServerItemType.ServerRecent]["role"].fontSize, self.LabelConfig[ServerItemType.ServerRecent]["role"].fontColor)		
		self.rootNode:addChild(self.nameLabel)		
		self.rootNode:addChild(self.stateLabel)	
		self.rootNode:addChild(self.roleCntLabel)	
		VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp(10, 0))		
		VisibleRect:relativePosition(self.stateLabel, self.nameLabel, LAYOUT_TOP_INSIDE+LAYOUT_RIGHT_INSIDE, ccp(-30, -10))
		VisibleRect:relativePosition(self.roleCntLabel, self.stateLabel, LAYOUT_RIGHT_OUTSIDE+LAYOUT_CENTER_Y)
	else
		self.nameLabel = createLabelWithStringFontSizeColorAndDimension("", "Arial", self.LabelConfig[serverType]["name"].fontSize, self.LabelConfig[serverType]["name"].fontColor)
		self.rootNode:addChild(self.nameLabel)	
		VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER)
	end				
end	

function ServerItemNode:setServerInfo(server)
	self:setName(server)
	self:setState(server)
end	

function ServerItemNode:setName(serverObj)
	if self.nameLabel and serverObj then 	
		local nameText
		if self.type==ServerItemType.ServerRecommend or self.type==ServerItemType.ServerArea then
			nameText = serverObj
		else
			nameText = serverObj:getServerName() or ""
		end
		
		self.nameLabel:setString(nameText)		
		if self.type == ServerItemType.ServerArea or self.type == ServerItemType.ServerRecommend then
			VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER)
		else
			VisibleRect:relativePosition(self.nameLabel, self.rootNode, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp(20, 0))
		end
	end
end

function ServerItemNode:setState(serverObj)
	if self.type==ServerItemType.ServerArea or self.type==ServerItemType.ServerRecommend then  
		return
	end

	if self.rootNode and self.stateLabel and serverObj then 
		local stateText = tonumber(serverObj:getServerState())
		local pic = "server_word_best.png"
		if stateText==-1 or stateText==0 or stateText==1 then 
			stateText = Config.LoginWords[8501]
			pic = "server_word_repair.png"
		elseif stateText==2 then 
			stateText = Config.LoginWords[8502]
			pic = "server_word_good.png"
		else
			stateText = Config.LoginWords[8503]
			pic = "server_word_best.png"
		end
		-- self.stateLabel:setString(stateText)
		-- VisibleRect:relativePosition(self.stateLabel, self.rootNode, LAYOUT_CENTER_Y+LAYOUT_RIGHT_INSIDE, ccp(-26, 10))
		
		if self.statePic then
			self.statePic:removeFromParentAndCleanup(true)
		end
		self.statePic = createSpriteWithFrameName(RES(pic))
		self.rootNode:addChild(self.statePic)
		VisibleRect:relativePosition(self.statePic, self.rootNode, LAYOUT_CENTER_Y+LAYOUT_RIGHT_INSIDE, ccp(-5, 0))	
		
		if self.type == ServerItemType.ServerRecent then 
			self.statePic:setScale(0.8)
		else	
			self.statePic:setScale(1)
		end
	end
end	

function ServerItemNode:setRoleCnt(cnt)
	if cnt and self.type == ServerItemType.ServerRecent then
		self.roleCntLabel:setString(tostring(cnt))
		VisibleRect:relativePosition(self.roleCntLabel, self.stateLabel, LAYOUT_RIGHT_OUTSIDE+LAYOUT_CENTER_Y)
	end
end

function ServerItemNode:update(server)
	self:setServerInfo(server)
end
