require("common.LoginBaseUI")
require("config.LoginWords")
require ("ui.login.SelectServer.ServerItemNode")

SignServerView = SignServerView or BaseClass(LoginBaseUI)

local visibleSize = CCDirector:sharedDirector():getVisibleSize()
local g_scale = VisibleRect:SFGetScale()

function SignServerView:__init()
	self.viewName = "SignServerView"	
    self.serverMgr = LoginWorld.Instance:getServerMgr()	
	self:createRootNode()
	self:createRecommendServer()
	self:createLoginBtn()
end	

function SignServerView:__delete()

end

function SignServerView:create()
	return SignServerView.New()
end	

function SignServerView:onEnter()
end	

function SignServerView:createRootNode()
    self.rootNode:setContentSize(visibleSize)
	self:makeMeCenter()	


	local bg 
	if SFGameConfig:getInstance():getQDCode2() == 20001 then    --口袋沙巴克
		bg =  CCSprite:create("loginUi/login/loading_sbk.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --王者争霸
		bg =  CCSprite:create("loginUi/login/denglu_bg_wzzb.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then --激战触龙神
		bg =  CCSprite:create("loginUi/login/denglu_bg_jz.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then --祖玛再临
		bg =  CCSprite:create("loginUi/login/denglu_bg_zm.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then --祖玛再临
		bg =  CCSprite:create("loginUi/login/denglu_bg_jz.jpg")
	else
		bg =  CCSprite:create("loginUi/login/loading_2.jpg")
	end

	G_setBigScale(bg)
	self.rootNode:addChild(bg)
	VisibleRect:relativePosition(bg, self.rootNode, LAYOUT_CENTER)


	local icon 
	if SFGameConfig:getInstance():getQDCode2() == 20001 then

	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --王者争霸
		icon = createSpriteWithFrameName(RES("login_loading_icon_wzzb.png"))
		icon:setScale(0.3)
		if icon then
			self.rootNode:addChild(icon)
			VisibleRect:relativePosition(icon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
		end
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then --激战触龙神
		icon = CCSprite:create("loginUi/login/login_loading_icon_jz.png")
		icon:setScale(0.5)
		if icon then
			self.rootNode:addChild(icon)
			VisibleRect:relativePosition(icon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
		end
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then --祖玛再临
		icon = CCSprite:create("loginUi/login/login_loading_icon_zm.png")
		if icon then
			self.rootNode:addChild(icon)
			VisibleRect:relativePosition(icon, self.rootNode, LAYOUT_LEFT_INSIDE+LAYOUT_TOP_INSIDE,ccp(5,-5))
		end
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then --祖玛再临
		icon = CCSprite:create("loginUi/login/login_loading_icon_qmcq.png")
		icon:setScale(0.5)
		if icon then
			self.rootNode:addChild(icon)
			VisibleRect:relativePosition(icon, self.rootNode, LAYOUT_LEFT_INSIDE+LAYOUT_TOP_INSIDE,ccp(5,-5))
		end
	else
		icon = createSpriteWithFrameName(RES("login_loading_icon.png"))
		if icon then
			self.rootNode:addChild(icon)
			VisibleRect:relativePosition(icon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
		end
	end

	
end	

function SignServerView:createRecommendServer()
    local hengtiao = createScale9SpriteWithFrameNameAndSize(RES("login_sr_hengtiao.png"),
    	                                                    CCSizeMake(600, 45),
    	                                                    CCRectMake(1,1,100,40))	
	self:addChild(hengtiao)
	VisibleRect:relativePosition(hengtiao, self.rootNode, LAYOUT_CENTER_X, ccp(0, 180))

	local tuijian = createLabelWithStringFontSizeColorAndDimension(Config.LoginWords[20001],
	                                                               "Arial",
	                                                               FSIZE("Size5"),
	                                                               FCOLOR("ColorYellow2"))
	self:addChild(tuijian)
	VisibleRect:relativePosition(tuijian, hengtiao, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp(50, 0))

	local huoqubtn = createButtonWithFramename(RES("touming.png"),
	                                           RES("touming.png"),
	                                           CCSizeMake(102, 33))
	huoqubtn:setOpacity(0)
	self:addChild(huoqubtn)
	VisibleRect:relativePosition(huoqubtn, hengtiao, LAYOUT_CENTER_Y+LAYOUT_RIGHT_OUTSIDE, ccp(-150, 0))
	local huanqu = createLabelWithStringFontSizeColorAndDimension(Config.LoginWords[20002],
	                                                               "Arial",
	                                                               FSIZE("Size5"),
	                                                               FCOLOR("ColorYellow2"))
	huoqubtn:addChild(huanqu)
	VisibleRect:relativePosition(huanqu, huoqubtn, LAYOUT_CENTER, ccp(0, 0))
    
    local  function AllServerShow()
        GlobalEventSystem:Fire(GameEvent.EVENT_SELECTALLSERVER_UI)
    end

	huoqubtn:addTargetWithActionForControlEvents(AllServerShow,CCControlEventTouchUpInside)

	local serverId = self.serverMgr:getRecentId()
	local recentNode
	if serverId and string.len(serverId)>0 then                        --判断是取最近登录还是推荐服务器 
	    recentNode = self:getRecentNode(serverId) 
	else  
	    local recommendList = self.serverMgr:getRecommendServerList()
	    if next(recommendList) ~=nil then
		    local serverIndex = recommendList[1]:getShowOrders()           --取第一个推荐服务器
		    recentNode = self:getRecommendNode(serverIndex)
		end
	end  

	if recentNode then 
        self:addChild(recentNode)
        VisibleRect:relativePosition(recentNode, hengtiao, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp(200, 0))
    end  
end

function SignServerView:getRecommendNode(serverIndex)
    local server = self.serverMgr:getServerByShowOrder(serverIndex)
    self.loginServer = server
    if server ~= nil then 
        local item = ServerItemNode.New(ServerItemType.ServerRecent, false)	
        if not item:getRootNode() then 
			return
		end
	    item:setServerInfo(server)		
	    item:getRootNode():setTag(100)
        local rootNode = item:getRootNode()
		return rootNode	
	 end   
end

function SignServerView:getRecentNode(serverId)       
    local recentId = string.split(serverId, "&")
	local count = table.size(recentId)

	local existCount = 0		
	local server = recentId[1]   --取第一个最近登录

	local id_start,_ = string.find(server, "=")
	if not id_start then 
		self.serverMgr:removeRecentServer(nil, nil)  -- 读取错误,清空保存最近服务器
		return
	end
	local id = string.sub(server, id_start+1, -1)

	local serverObj = self.serverMgr:getServerById(id)
	self.loginServer = serverObj						
	if serverObj then 	
		existCount = existCount + 1	
		local item = ServerItemNode.New(ServerItemType.ServerRecent, false)	
		if not item:getRootNode() then 
			return
		end
		item:getRootNode():setTag(100)
		item:setServerInfo(serverObj)
		local rootNode = item:getRootNode()
		return rootNode	
	end	
end	

function SignServerView:createLoginBtn()
    self.btnEnterGame = createButtonWithFramename(RES("login_sr_enter_2.png"), RES("login_sr_enter_2.png"))	
	self.btnEnterGame:setScale(g_scale)
	self:addChild(self.btnEnterGame)
	VisibleRect:relativePosition(self.btnEnterGame, self.rootNode, LAYOUT_CENTER_X, ccp(0, 95))

	local LoginConnect = function ()
	    if self.loginServer then
            self.serverMgr:handleServerLogin(self.loginServer)
        end    
    end

    self.btnEnterGame:addTargetWithActionForControlEvents(LoginConnect,CCControlEventTouchUpInside)																				
end	

