require("common.baseclass")

LoadingSence= LoadingSence or BaseClass()
local visibleSize = CCDirector:sharedDirector():getVisibleSize()
function LoadingSence:__init ()
	local function ccTouchHandler(eventType, x,y)
		return self:touchHandler(eventType, x, y)
	end
	
	self.rootNode = CCLayer:create()
	self.rootNode:setTouchEnabled(true)
	self.rootNode:registerScriptTouchHandler(ccTouchHandler, false,UIPriority.LoadingHUD, true)
	self.rootNode:setContentSize(visibleSize)
	self.rootNode:retain()
	self.delay = 3
	self.removeId = -1
	self.rebackId = -1
	self.fadeIn = 0.2
	self.time = 0.05
	
	self.limitLessTime = 1
	self.reBackTime = 0.1
	self.tallyTime = 0
	self.bRemove = false
	
	self:initBlackGround()
	self:initLogo()
	self:playAction1()
end

function LoadingSence:__delete()
	self.bRemove = true
	self:removeLoadingSence()
	self:deleteScheduler()
	self.rootNode = nil
end

function LoadingSence:getRootNode()
	return self.rootNode
end

function LoadingSence:initBlackGround()


	local bg 
	if SFGameConfig:getInstance():getQDCode2() == 20001 then
		bg = createSpriteWithFrameName(RES("ui/srcq_new_add/login_loading_swith_scene_sbk.jpg"))
	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --王者争霸
		bg = createSpriteWithFrameName(RES("ui/srcq_new_add/login_loading_swith_scene_sbk.jpg"))
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then --激战触龙神
		bg = CCSprite:create("loginUi/login/loading_jz.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then --祖玛再临
		bg = CCSprite:create("loginUi/login/loading_zm.jpg")
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then --祖玛再临
		bg = CCSprite:create("loginUi/login/loading_jz.jpg")
	else
		bg = createSpriteWithFrameName(RES("ui/srcq_new_add/login_loading_swith_scene.jpg"))
	end

	if bg ~= nil then
		G_setBigScale(bg)
		self.rootNode:addChild(bg)
		VisibleRect:relativePosition(bg,self.rootNode,LAYOUT_CENTER)
	end

	local gameIcon 
	if SFGameConfig:getInstance():getQDCode2() == 20001 then
		gameIcon = createSpriteWithFrameName(RES("ui/srcq_new_add/common_loading_logo_sbk.png"))

		if gameIcon ~= nil then
			self.rootNode:addChild(gameIcon)
			VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_LEFT_INSIDE+LAYOUT_TOP_INSIDE,ccp(20,-20))
		end
	elseif SFGameConfig:getInstance():getQDCode2() == 20002 then --王者争霸
		gameIcon = createSpriteWithFrameName(RES("login_loading_icon_wzzb.png"))
		gameIcon:setScale(0.5)

		if gameIcon ~= nil then
			self.rootNode:addChild(gameIcon)
			VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
		end
	elseif SFGameConfig:getInstance():getQDCode2() == 20003 then --激战触龙神
		gameIcon = CCSprite:create("loginUi/login/login_loading_icon_jz.png")
		gameIcon:setScale(0.5)
		self.rootNode:addChild(gameIcon)
		VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
	elseif SFGameConfig:getInstance():getQDCode2() == 20004 then --祖玛再临
		gameIcon = CCSprite:create("loginUi/login/login_loading_icon_zm.png")
		self.rootNode:addChild(gameIcon)
		VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
	elseif SFGameConfig:getInstance():getQDCode2() == 30001 then --祖玛再临
		gameIcon = CCSprite:create("loginUi/login/login_loading_icon_qmcq.png")
		gameIcon:setScale(0.5)
		self.rootNode:addChild(gameIcon)
		VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE,ccp(-5,-5))
	else
		gameIcon = createSpriteWithFrameName(RES("ui/srcq_new_add/common_loading_logo.png"))

		if gameIcon ~= nil then
			self.rootNode:addChild(gameIcon)
			gameIcon:setScale(1.5)
			VisibleRect:relativePosition(gameIcon, self.rootNode, LAYOUT_CENTER,ccp(0,50))
		end
	end

	

end

function LoadingSence:setDelay(nDelay)
	self.delay = nDelay
end

function LoadingSence:setLoadingProgress(num)
	self.progressNum = num
end

function LoadingSence:initLogo()

	self.font = createSpriteWithFrameName(RES("login_loadSence_font.png"))
	self.rootNode:addChild(self.font)
	VisibleRect:relativePosition(self.font,self.rootNode,LAYOUT_CENTER+LAYOUT_BOTTOM_INSIDE,ccp(0,150))
	
	self.point = {}
	for i=1,3 do
		self.point[i] = createSpriteWithFrameName(RES("login_loadSence_point.png"))
		self.font:addChild(self.point[i])
		self.point[i]:setOpacity(0)
		if i==1 then
			VisibleRect:relativePosition(self.point[i],self.font,LAYOUT_CENTER+LAYOUT_RIGHT_OUTSIDE,ccp(5,0))
		else
			VisibleRect:relativePosition(self.point[i],self.point[i-1],LAYOUT_CENTER+LAYOUT_RIGHT_OUTSIDE,ccp(5,0))
		end
	end
end

function LoadingSence:playAction1()
	local fadeIn = CCFadeIn:create(self.fadeIn)
	local dalayTime =  CCDelayTime:create(self.time)
	
	local function finishFogCallback()
		self:playAction2()
	end
	local callbackAction = CCCallFunc:create(finishFogCallback)
	
	local actionArray = CCArray:create()
	actionArray:addObject(fadeIn)
	actionArray:addObject(dalayTime)
	actionArray:addObject(callbackAction)
	self.point[1]:runAction(CCSequence:create(actionArray))
end

function LoadingSence:playAction2()
	local fadeIn = CCFadeIn:create(self.fadeIn)
	local dalayTime =  CCDelayTime:create(self.time)
	
	local function finishFogCallback()
		self:playAction3()
	end
	local callbackAction = CCCallFunc:create(finishFogCallback)
	
	local actionArray = CCArray:create()
	actionArray:addObject(fadeIn)
	actionArray:addObject(dalayTime)
	actionArray:addObject(callbackAction)
	self.point[2]:runAction(CCSequence:create(actionArray))
end

function LoadingSence:playAction3()
	local fadeIn = CCFadeIn:create(self.fadeIn)
	local dalayTime =  CCDelayTime:create(self.time)
	
	local function finishFogCallback()
		for i=1,3 do
			self.point[i]:setOpacity(0)
		end
		self:playAction4()
	end
	local callbackAction = CCCallFunc:create(finishFogCallback)
	
	local actionArray = CCArray:create()
	actionArray:addObject(fadeIn)
	actionArray:addObject(dalayTime)
	actionArray:addObject(callbackAction)
	self.point[3]:runAction(CCSequence:create(actionArray))
end

function LoadingSence:playAction4()
	for i=1,3 do
		local fadeOut = CCFadeOut:create(self.fadeIn)
		
		local function finishFogCallback()
			if i==3 then
				self:playAction1()
			end
		end
		local callbackAction = CCCallFunc:create(finishFogCallback)
		
		local actionArray = CCArray:create()
		actionArray:addObject(fadeOut)
		actionArray:addObject(callbackAction)
		self.point[i]:runAction(CCSequence:create(actionArray))
	end
	
end

function LoadingSence:show()
	if self.removeId ~= -1 then
		return
	end
	
	if self.hideFunction == nil then
		self.hideFunction = function ()
			self.bRemove = true
			self:deleteScheduler()
		end
	end
	self.removeId =CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(self.hideFunction, self.delay, false)
	self.bRemove = false
end

function LoadingSence:deleteScheduler()
	if self.removeId ~= -1 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.removeId)
		self.removeId = -1
	end
	self:reBackTimeFun()
end

function LoadingSence:reBackTimeFun()
	if self.rebackId ~= -1 then
		return
	end
	if self.reBackFunction == nil then
		self.reBackFunction = function ()
			self.bRemove = true
			self:removeLoadingSence()
		end
	end
	self.rebackId =CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(self.reBackFunction, self.reBackTime, false)
end

function LoadingSence:removeLoadingSence()
	if self.bRemove then
		if self.rootNode then
			self.rootNode:removeFromParentAndCleanup(true)
			if self.rootNode:retainCount() > 0 then
				self.rootNode:release()				
			end		
			self.rootNode = nil		
			if self.removeId ~= -1 then
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.removeId)
				self.removeId = -1
			end
			if self.rebackId ~= -1 then
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(self.rebackId)
				self.rebackId = -1
			end
		end
	end
end

function LoadingSence:touchHandler(eventType, x, y)
	if self.rootNode then
		if self.rootNode:isVisible() and self.rootNode:getParent() then
			local parent =self.rootNode:getParent()
			local point = parent:convertToNodeSpace(ccp(x,y))
			local size = parent:getContentSize()
			local rect = CCRectMake(0,0,size.width,size.height)
			if self.touchArea and self.touchArea:containsPoint(point)  then
				return 0
			else
				if rect:containsPoint(point) then
					return 1
				else
					return 0
				end
			end
		else
			return 0
		end
	end
end