-- dump table, 快速的
function print_r(aTable, title)

    if not aTable then return end
    if type(aTable) ~= "table" then 
        print("table:",aTable)
    return end

    local enterStr  = "\n"
    local indentStr = "    "
    local equalStr  = " = "
    local commaStr  = ","
    local leftBrace = "{"
    local rightBrace = "}"

    local strParts  = {}

    local function recursionFunc(aTable, indent)

        -- table左花括号
        table.insert(strParts, enterStr)
        table.insert(strParts, string.rep(indentStr, indent))
        table.insert(strParts, leftBrace)
        table.insert(strParts, enterStr)

        -- 花括号里面的内容再缩进2格
        local curTabStr = string.rep(indentStr, indent + 1)

        for k,v in pairs(aTable) do

            -- table类型 递归
            if type(v) == "table" then
                table.insert(strParts, curTabStr)
                table.insert(strParts, tostring(k))
                table.insert(strParts, equalStr)
                recursionFunc(v, indent + 1)

            else
                -- 其他类型 直接打印
                table.insert(strParts, curTabStr)
                table.insert(strParts, tostring(k))
                table.insert(strParts, equalStr)
                table.insert(strParts, tostring(v))
                table.insert(strParts, commaStr)
                table.insert(strParts, enterStr)
            end
        end

        -- table右花括号
        table.insert(strParts, string.rep(indentStr, indent))
        table.insert(strParts, rightBrace)
        table.insert(strParts, commaStr)
        table.insert(strParts, enterStr)
    end

    if title then
        table.insert(strParts, title)
        table.insert(strParts, equalStr)
    end
    recursionFunc(aTable, 0)

    CCLuaLog(table.concat(strParts))
end
